"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var ImageLoader = function ImageLoader(_ref) {
  var src = _ref.src,
    alt = _ref.alt,
    onLoad = _ref.onLoad,
    onError = _ref.onError,
    optimize = _ref.optimize,
    currentBreakpoint = _ref.currentBreakpoint;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isLoaded = _useState2[0],
    setIsLoaded = _useState2[1];
  var imageRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var _imageRef$current;
    if (imageRef !== null && imageRef !== void 0 && (_imageRef$current = imageRef.current) !== null && _imageRef$current !== void 0 && _imageRef$current.complete) {
      setIsLoaded(true);
    }
  }, []);
  var handleLoad = function handleLoad(event) {
    setIsLoaded(true);
    onLoad(event);
  };
  var generateSrcSet = function generateSrcSet(src) {
    var sizes = {
      small: "".concat(src, "?size=small 576w"),
      medium: "".concat(src, "?size=medium 768w"),
      large: "".concat(src, "?size=large 992w"),
      xlarge: "".concat(src, "?size=xlarge 1200w")
    };
    return "".concat(sizes.small, ", ").concat(sizes.medium, ", ").concat(sizes.large, ", ").concat(sizes.xlarge);
  };
  var optimizedSrcSet = optimize ? generateSrcSet(src) : null;
  return /*#__PURE__*/_react["default"].createElement("img", {
    src: optimize ? "".concat(src, "?size=").concat(currentBreakpoint) : src,
    srcSet: optimizedSrcSet,
    sizes: "(max-width: 576px) 576px, (max-width: 768px) 768px, (max-width: 992px) 992px, 1200px",
    alt: alt,
    onLoad: onLoad,
    onError: onError,
    style: {
      width: '100%',
      height: 'auto'
    }
  });
};
ImageLoader.propTypes = {
  src: _propTypes["default"].string.isRequired,
  alt: _propTypes["default"].string,
  onLoad: _propTypes["default"].func,
  onError: _propTypes["default"].func,
  optimize: _propTypes["default"].bool,
  currentBreakpoint: _propTypes["default"].string
};
ImageLoader.defaultProps = {
  alt: '',
  onLoad: function onLoad() {},
  onError: function onError() {},
  optimize: false,
  currentBreakpoint: 'large'
};
var _default = exports["default"] = ImageLoader;